=begin

earth_info.rb

Local mail library for a mail forwarding control script
Copyright (C) 2001-2003 Masaharu FUJITA

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the author by:
        e-mail: m@fjts.org
        url: http://fjts.org/~m/Soft/Ruby/earth.rb/
=end

# class for create format
class EarthFormat
  def initialize(type,format,from,subject,tocc,date,mail_number,
		 count_number = 0,match = 'unknown',subject_max = -1,
		 use_cut = true)
    @type = type
    @format = format
    @from = from
    @subject = subject
    @tocc = tocc
    @date = date
    @mail_number = mail_number
    @count_number = count_number
    @match = match
    @subject_max = subject_max
    @use_cut = use_cut

    @return_format_string = ''
    @return_format_string_byte = 0
  end # def initialize

  def create
    if not @format
      return
    end

    string = eval(@format)
    if @subject_max != -1
      tmp = ''
      tmp_byte = 0
      string.each_char do |char|
	if char.mbchar?
	  tmp_byte += 2
	else
	  tmp_byte += 1
	end

	if tmp_byte >= @subject_max
	  break
	end

	tmp += char
      end # string.each_char do |char|

      string = tmp
    end # if @subject_max != -1

    if @use_cut
      cut = EarthCutString.new(@type,string)
      @return_format_string = cut.string
      @return_format_string_byte = cut.byte
    else
      @return_format_string = string
    end
  end # def create

  def format
    @return_format_string
  end

  def byte
    @return_format_string_byte
  end
end # class EarthFormat
